package dev.shadowsoffire.apotheosis.ench.objects;

import java.util.Iterator;
import net.minecraft.world.item.EnchantedBookItem;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.Items;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Rarity;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.enchantment.Enchantment;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.apotheosis.ench.table.IEnchantableItem;
import net.minecraft.world.item.BookItem;

public class TomeItem extends BookItem implements IEnchantableItem
{
    final ItemStack rep;
    final EnchantmentCategory type;
    
    public TomeItem(final Item rep, final EnchantmentCategory type) {
        super(new Item.Properties());
        this.type = type;
        this.rep = new ItemStack((ItemLike)rep);
        EnchModule.TYPED_BOOKS.add(this);
    }
    
    public boolean isBookEnchantable(final ItemStack stack, final ItemStack book) {
        return stack.m_41613_() == 1;
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack, final Enchantment enchantment) {
        if (this.type == null) {
            return EnchModule.TYPED_BOOKS.stream().filter(b -> b != this).allMatch(b -> !enchantment.m_6081_(new ItemStack((ItemLike)b)));
        }
        return enchantment.canApplyAtEnchantingTable(this.rep);
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level worldIn, final List<Component> tooltip, final TooltipFlag flagIn) {
        tooltip.add((Component)Component.m_237115_("info.apotheosis." + ForgeRegistries.ITEMS.getKey((Object)this).m_135815_()).m_130940_(ChatFormatting.GRAY));
        if (stack.m_41793_()) {
            tooltip.add((Component)Component.m_237115_("info.apotheosis.tome_error").m_130940_(ChatFormatting.RED));
        }
    }
    
    public Rarity m_41460_(final ItemStack stack) {
        return stack.m_41793_() ? Rarity.UNCOMMON : super.m_41460_(stack);
    }
    
    public InteractionResultHolder<ItemStack> m_7203_(final Level world, final Player player, final InteractionHand hand) {
        final ItemStack stack = player.m_21120_(hand);
        if (stack.m_41793_()) {
            final ItemStack book = new ItemStack((ItemLike)Items.f_42690_, stack.m_41613_());
            EnchantmentHelper.m_44865_(EnchantmentHelper.m_44831_(stack), book);
            return (InteractionResultHolder<ItemStack>)InteractionResultHolder.m_19096_((Object)book);
        }
        return (InteractionResultHolder<ItemStack>)InteractionResultHolder.m_19098_((Object)stack);
    }
    
    public ItemStack onEnchantment(ItemStack stack, final List<EnchantmentInstance> enchantments) {
        stack = new ItemStack((ItemLike)Items.f_42690_);
        for (final EnchantmentInstance inst : enchantments) {
            EnchantedBookItem.m_41153_(stack, inst);
        }
        return stack;
    }
    
    public boolean forciblyAllowsTableEnchantment(final ItemStack stack, final Enchantment enchantment) {
        return this.canApplyAtEnchantingTable(stack, enchantment);
    }
}
